@echo off
setlocal

if "%1"=="" goto SHOW_USAGE

set ISO_IMAGE=%1
set DRIVE_REMOVABLE=2

if not exist %ISO_IMAGE% goto ISO_NOT_EXIST

set /p DriveName=Please enter the drive letter of your USB Flash key (ex. e:): 

deps\cmdline\GetDriveType %DriveName%
set DRIVE_TYPE=%errorlevel%

if not %DRIVE_TYPE%==%DRIVE_REMOVABLE% goto DRIVE_TYPE_ERROR

set /P FormatConfirm=Drive %DriveName% will be formatted, and all data will be lost.  Are you sure you want to continue? (y/n) 

if /I %FormatConfirm%==y goto FORMAT

if /I %FormatConfirm%==yes goto FORMAT

goto END

:FORMAT

format %DriveName% /X /FS:FAT32 /V:ISXC /Y

if errorlevel 1 goto ERROR

echo Extracting ISO Image...
mkdir iso
deps\7-zip\7z x %ISO_IMAGE% -y -oiso ks.cfg isolinux\* images\*

echo Copying files to %DriveName%...
mkdir %DriveName%\iso\images
mkdir %DriveName%\syslinux
copy %ISO_IMAGE% %DriveName%\iso\
rem copy .\deps\updates.img %DriveName%\iso\
copy .\iso\isolinux\boot.cat %DriveName%\syslinux\
copy .\iso\isolinux\boot.msg %DriveName%\syslinux\
copy .\iso\isolinux\initrd.img %DriveName%\syslinux\
copy .\iso\isolinux\splash.lss %DriveName%\syslinux\
copy .\iso\isolinux\vmlinuz %DriveName%\syslinux\
copy .\iso\images\install.img %DriveName%\iso\images\
.\deps\cmdline\sed s/cdrom/hd:LABEL=ISXC/ .\iso\isolinux\isolinux.cfg > %DriveName%\syslinux\syslinux.cfg
.\deps\cmdline\sed -e "0,/cdrom/s/cdrom/harddrive --partition=LABEL=ISXC --dir=\/iso/" -e "s/^reboot.*/reboot/" -e "/^%%post/,/^%%end/ { /^%%end/ d }" .\iso\ks.cfg > .\ks.new
.\deps\cmdline\sed -e "$ a\ <br>chvt 1<br>echo -e \"\\a\" > /dev/tty1<br>echo -e \"\\n\\nSystem restore complete.\\n\\n\" > /dev/tty1<br>sleep 1<br>echo -e \"\\a\" > /dev/tty1<br>echo -e \"Press enter to reboot your StruxureWare Data Center Expert server.\\n\\nRemove your USB flash key when the system reboots.\\n\\n\" > /dev/tty1<br>read<br>echo -e \"System Rebooting...\" > /dev/tty1<br><br>%%end<br>" .\ks.new > .\ks.new2
.\deps\cmdline\sed -e "s/<br>/\n/g" .\ks.new2 > %DriveName%\ks.cfg
del .\ks.new
del .\ks.new2
.\deps\syslinux\syslinux -ma %DriveName%

echo Cleaning up...
rmdir /s /q iso

:FINISH
echo Done!
goto END

:ISO_NOT_EXIST
echo The specified .iso image does not exist
pause
goto END

:DRIVE_TYPE_ERROR
echo The specified drive is not a removable drive
pause
goto END

:ERROR
echo An error was encountered.
pause
goto END

:SHOW_USAGE
echo usage:
echo   mkDCExpertRestoreUsbKey.bat [ISO File]
pause
goto END

:END
